<?php

/**
 * Created by Andrey Nekrylov
 * Date: 04.11.2016
 * Time: 5:42
 */
class ControllerExtensionShippingB2cpl extends Controller {
	private $error = array();

	public function install() {
		$this->load->model( 'setting/event' );
		$this->model_setting_event->addEvent( 'b2cpl', 'catalog/model/checkout/order/addOrderHistory/after', 'extension/shipping/b2cpl/onOrderAdd' );

	}

	public function uninstall() {
		$this->load->model( 'setting/event' );
		$this->model_setting_event->deleteEvent( 'b2cpl' );
	}

	public function index() {
		$this->load->language( 'extension/shipping/b2cpl' );
		$this->document->setTitle( $this->language->get( 'heading_title' ) );
		$this->load->model( 'setting/setting' );

		if ( ( $this->request->server['REQUEST_METHOD'] == 'POST' ) && $this->validate() ) {
			$this->model_setting_setting->editSetting( 'shipping_b2cpl', $this->request->post );
			$this->session->data['success'] = $this->language->get( 'text_success' );
			$this->response->redirect( $this->url->link( 'extension/extension', 'user_token=' . $this->session->data['user_token'] . '&type=shipping', 'SSL' ) );
		}


		$data['breadcrumbs'][] = array(
			'text' => $this->language->get( 'text_home' ),
			'href' => $this->url->link( 'common/dashboard', 'user_token=' . $this->session->data['user_token'], 'SSL' )
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get( 'text_extension' ),
			'href' => $this->url->link( 'extension/extension', 'user_token=' . $this->session->data['user_token'] . '&type=shipping', 'SSL' )
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get( 'heading_title' ),
			'href' => $this->url->link( 'extension/shipping/b2cpl', 'user_token=' . $this->session->data['user_token'], 'SSL' )
		);

		$data['action'] = $this->url->link( 'extension/shipping/b2cpl', 'user_token=' . $this->session->data['user_token'], 'SSL' );

		$data['cancel'] = $this->url->link( 'extension/extension', 'user_token=' . $this->session->data['user_token'] . '&type=shipping', 'SSL' );

		$data['heading_title'] = $this->language->get( 'heading_title' );

		$data['text_edit']      = $this->language->get( 'text_edit' );
		$data['text_enabled']   = $this->language->get( 'text_enabled' );
		$data['text_disabled']  = $this->language->get( 'text_disabled' );
		$data['text_all_zones'] = $this->language->get( 'text_all_zones' );
		$data['text_none']      = $this->language->get( 'text_none' );
		$data['yes']            = $this->language->get( 'yes' );
		$data['no']             = $this->language->get( 'no' );
		$data['region']         = array(
			'77' => $this->language->get( 'r77' ),
			'78' => $this->language->get( 'r78' ),
			'16' => $this->language->get( 'r16' )
		);

		$data['entry_shop_name']          = $this->language->get( 'entry_shop_name' );
		$data['entry_geo_zone']           = $this->language->get( 'entry_geo_zone' );
		$data['entry_status']             = $this->language->get( 'entry_status' );
		$data['entry_sort_order']         = $this->language->get( 'entry_sort_order' );
		$data['entry_b2cpl_client']       = $this->language->get( 'entry_b2cpl_client' );
		$data['entry_b2cpl_key']          = $this->language->get( 'entry_b2cpl_key' );
		$data['entry_b2cpl_pak_type']     = $this->language->get( 'entry_b2cpl_pak_type' );
		$data['entry_b2cpl_type']         = $this->language->get( 'entry_b2cpl_type' );
		$data['entry_b2cpl_weight']       = $this->language->get( 'entry_b2cpl_weight' );
		$data['entry_b2cpl_is_fix_price'] = $this->language->get( 'entry_b2cpl_is_fix_price' );
		$data['entry_b2cpl_fix_price']    = $this->language->get( 'entry_b2cpl_fix_price' );
		$data['entry_b2cpl_region']       = $this->language->get( 'entry_b2cpl_region' );

		$data['b2cpl_regions'] = array( '77', '78', '16' );
		$data['pak_types']     = array( 'call ИМ', 'call', 'call омни' );
		$data['types']         = array(
			'+post'    => $this->language->get( '+post' ),
			'-post'    => $this->language->get( '-post' ),
			'post_add' => $this->language->get( 'post_add' )
		);


		$data['help_shop_name']     = $this->language->get( 'help_shop_name' );
		$data['help_weight']        = $this->language->get( 'help_weight' );
		$data['entry_b2cpl_region'] = $this->language->get( 'entry_b2cpl_region' );

		$data['button_save']   = $this->language->get( 'button_save' );
		$data['button_cancel'] = $this->language->get( 'button_cancel' );

		if ( isset( $this->error['warning'] ) ) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if ( isset( $this->request->post['b2cpl_shop_name'] ) ) {
			$data['b2cpl_shop_name'] = $this->request->post['b2cpl_shop_name'];
		} else {
			$data['b2cpl_shop_name'] = $this->config->get( 'b2cpl_shop_name' );
		}

		if ( isset( $this->request->post['b2cpl_geo_zone_id'] ) ) {
			$data['b2cpl_geo_zone_id'] = $this->request->post['b2cpl_geo_zone_id'];
		} else {
			$data['b2cpl_geo_zone_id'] = $this->config->get( 'b2cpl_geo_zone_id' );
		}

		$this->load->model( 'localisation/geo_zone' );

		$data['geo_zones'] = $this->model_localisation_geo_zone->getGeoZones();

		if ( isset( $this->request->post['shipping_b2cpl_status'] ) ) {
			$data['shipping_b2cpl_status'] = $this->request->post['shipping_b2cpl_status'];
		} else {
			$data['shipping_b2cpl_status'] = $this->config->get( 'shipping_b2cpl_status' );
		}

		if ( isset( $this->request->post['b2cpl_sort_order'] ) ) {
			$data['b2cpl_sort_order'] = $this->request->post['b2cpl_sort_order'];
		} else {
			$data['b2cpl_sort_order'] = $this->config->get( 'b2cpl_sort_order' );
		}

		if ( isset( $this->request->post['b2cpl_client'] ) ) {
			$data['b2cpl_client'] = $this->request->post['b2cpl_client'];
		} else {
			$data['b2cpl_client'] = $this->config->get( 'b2cpl_client' );
		}

		if ( isset( $this->request->post['b2cpl_key'] ) ) {
			$data['b2cpl_key'] = $this->request->post['b2cpl_key'];
		} else {
			$data['b2cpl_key'] = $this->config->get( 'b2cpl_key' );
		}

		if ( isset( $this->request->post['b2cpl_region'] ) ) {
			$data['b2cpl_region'] = $this->request->post['b2cpl_region'];
		} else {
			$data['b2cpl_region'] = $this->config->get( 'b2cpl_region' );
		}

		if ( isset( $this->request->post['b2cpl_pak_type'] ) ) {
			$data['b2cpl_pak_type'] = $this->request->post['b2cpl_pak_type'];
		} else {
			$data['b2cpl_pak_type'] = $this->config->get( 'b2cpl_pak_type' );
		}

		if ( isset( $this->request->post['b2cpl_type'] ) ) {
			$data['b2cpl_type'] = $this->request->post['b2cpl_type'];
		} else {
			$data['b2cpl_type'] = $this->config->get( 'b2cpl_type' );
		}

		if ( isset( $this->request->post['b2cpl_weight'] ) ) {
			$data['b2cpl_weight'] = $this->request->post['b2cpl_weight'];
		} else {
			$data['b2cpl_weight'] = $this->config->get( 'b2cpl_weight' );
		}

		if ( isset( $this->request->post['b2cpl_is_fix_price'] ) ) {
			$data['b2cpl_is_fix_price'] = $this->request->post['b2cpl_is_fix_price'];
		} else {
			$data['b2cpl_is_fix_price'] = $this->config->get( 'b2cpl_is_fix_price' );
		}

		if ( isset( $this->request->post['b2cpl_fix_price'] ) ) {
			$data['b2cpl_fix_price'] = $this->request->post['b2cpl_fix_price'];
		} else {
			$data['b2cpl_fix_price'] = $this->config->get( 'b2cpl_fix_price' );
		}

		$data['header']      = $this->load->controller( 'common/header' );
		$data['column_left'] = $this->load->controller( 'common/column_left' );
		$data['footer']      = $this->load->controller( 'common/footer' );

		$this->response->setOutput( $this->load->view( 'extension/shipping/b2cpl', $data ) );
	}

	protected function validate() {
		if ( ! $this->user->hasPermission( 'modify', 'extension/shipping/b2cpl' ) ) {
			$this->error['warning'] = $this->language->get( 'error_permission' );
		}

		return ! $this->error;
	}


	function onOrderEdit( $data ) {

	}

	function onOrderHistoryEdit( $order_id ) {

	}

	function onOrderAdd( $route, $output, $order_id, $order_status_id ) {

//		$this->generateCsv($order_id);
//		$this->sendCsv($order_id);
		echo 'Попал';
	}


}