<?php

/**
 * Created by Andrey Nekrylov
 * Date: 14.11.2016
 * Time: 10:53
 */
class ControllerExtensionShippingB2cpl extends Controller {
	function onOrderAdd( $route, $data, $order_status_id ) {
		$order_id        = $data[0];
		$order_status_id = $data[1];
//		$this->generateCsv( $order_id );
//		$this->sendCsv( $order_id );
		$this->sendPostJson( $order_id );
	}

	public function prepareJson( $order_id ) {

		if ( ! $order_id ) {
			return false;
		}

		$this->load->model( 'checkout/order' );
//	    $path = $this->getOrderFile($order_id);
//	    echo $path;
//	    $file = fopen($path, 'wb');
		$order_data = $this->model_checkout_order->getOrder( $order_id );

		if ( $order_data['customer_id'] ) {
			$customer_id = $order_data['customer_id'];
		} else {
			$customer_id = '';
		}

		if ( $order_data['shipping_city'] ) {
			$city = $order_data['shipping_city'];
		} elseif ( $order_data['payment_city'] ) {
			$city = $order_data['payment_city'];
		} else {
			$city = 'Не указан'; //Поле обязательно к заполнению
		}

		if ( $order_data['shipping_address_1'] ) {
			$address = $order_data['shipping_address_1'];
		} elseif ( $order_data['payment_address_1'] ) {
			$address = $order_data['payment_address_1'];
		} else {
			$address = '';
		}

		//индекс не должен быть пустым
		if ( $order_data['shipping_postcode'] ) {
			$index = $order_data['shipping_postcode'];
		} elseif ( $order_data['payment_postcode'] ) {
			$index = $order_data['payment_postcode'];
		} elseif ( 'call ИМ' != $this->config->get( 'b2cpl_pak_type' ) ) {
			$index = '101000'; // Индекс Москвы по умолчанию
		}

		if ( $order_data['firstname'] ) {
			$fio = $order_data['firstname'] . ' ' . $order_data['lastname'];
		} else {
			$fio = '';
		}

		if ( $order_data['telephone'] ) {
			$tel = $order_data['telephone'];
		} else {
			$tel = '';
		}

		if ( $order_data['email'] && ( ! strstr( $order_data['email'], '@localhost' ) ) ) {
			$email = $order_data['email'];
		} else {
			$email = '';
		}


		$order_shipping_query = $this->db->query( "SELECT * FROM `" . DB_PREFIX . "order_total` WHERE order_id = '" . (int) $order_id . "' AND code='shipping' " );
		if ( $order_shipping_query->num_rows ) {
			$order_shipping = (float) $order_shipping_query->row['value'];
		} else {
			$order_shipping = 0;
		}

		//оплачен ли заказ
		$is_paid = 0;
//            if($order_data['order_status_id']==18){ //18-id статуса Оплачено
//                $is_paid=1;
//            }else{
//                $is_paid=0;
//            }

		if ( $is_paid ) {
			$order_shipping_to_pay = 0;

		} else {
			$order_shipping_to_pay = $order_shipping;
		}

		//товары
		$order_products      = array();
		$order_product_query = $this->db->query( "SELECT op.*, p.sku, p.weight, p.weight_class_id FROM " . DB_PREFIX . "order_product op LEFT JOIN " . DB_PREFIX . "product p ON ( op.product_id = p.product_id ) WHERE order_id = '" . (int) $order_id . "'" );

		$total_sum_w_deliv = 0;
		foreach ( $order_product_query->rows as $product ) {

			$option_data = array();

			$order_option_query = $this->db->query( "SELECT  oo . * , po.option_id FROM " . DB_PREFIX . "order_option oo LEFT JOIN " . DB_PREFIX . "product_option po ON ( po.product_option_id = oo.product_option_id ) WHERE order_id = '" . (int) $order_id . "' AND order_product_id = '" . (int) $product['order_product_id'] . "'" );

			foreach ( $order_option_query->rows as $option ) {
				if ( $option['type'] != 'file' ) {
					$value = $option['value'];
				} else {
					$value = utf8_substr( $option['value'], 0, utf8_strrpos( $option['value'], '.' ) );
				}


				$option_data[] = $option['name'] . ': ' . ( utf8_strlen( $value ) > 20 ? utf8_substr( $value, 0, 20 ) . '..' : $value );
			}
			$option_data_str = implode( ', ', $option_data );
			if ( $option_data_str ) {
				$product_name = $product['name'] . ' (' . $option_data_str . ')';
			} else {
				$product_name = $product['name'];
			}
			if ( $is_paid ) {
				$price_to_pay = 0;

			} else {
				$price_to_pay = $product['price'] + ( $this->config->get( 'config_tax' ) ? $product['tax'] : 0 );
			}

			$product_weight = $product['weight'];
			$weight_code    = utf8_strtoupper( $this->weight->getUnit( $product['weight_class_id'] ) );
			if ( $weight_code == 'KG' || $weight_code == 'КГ' ) {
				$product_weight *= 1000;
			}

			$order_products[]  = array(
				'name'         => $product_name,
				'sku'          => $product['sku'],
				'model'        => $product['model'],
				'weight'       => (int) $product_weight,
				'option'       => $option_data,
				'quantity'     => $product['quantity'],
				'price_nf'     => ( $product['price'] + ( $this->config->get( 'config_tax' ) ? $product['tax'] : 0 ) ),
				'price_to_pay' => $price_to_pay,
				'price'        => $this->currency->format( $product['price'] + ( $this->config->get( 'config_tax' ) ? $product['tax'] : 0 ), $order_data['currency_code'], $order_data['currency_value'] ),
				'total'        => $this->currency->format( $product['total'] + ( $this->config->get( 'config_tax' ) ? ( $product['tax'] * $product['quantity'] ) : 0 ), $order_data['currency_code'], $order_data['currency_value'] )
			);
			$total_sum_w_deliv += ( $product['price'] * $product['quantity'] + ( $this->config->get( 'config_tax' ) ? $product['tax'] * $product['quantity'] : 0 ) );
		}

	}

	public function generateCsv( $order_id ) { //генерация cvs файла по id заказа

		if ( $order_id ) {
			$this->load->model( 'checkout/order' );
			$path = $this->getOrderFile( $order_id );
			echo $path;
			$file = fopen( $path, 'wb' );

			$order_data = array();
			$order_data = $this->model_checkout_order->getOrder( $order_id );

			if ( $order_data['customer_id'] ) {
				$customer_id = $order_data['customer_id'];
			} else {
				$customer_id = '';
			}

			if ( $order_data['shipping_city'] ) {
				$city = $order_data['shipping_city'];
			} elseif ( $order_data['payment_city'] ) {
				$city = $order_data['payment_city'];
			} else {
				$city = 'Не указан'; //Поле обязательно к заполнению
			}

			if ( $order_data['shipping_address_1'] ) {
				$address = $order_data['shipping_address_1'];
			} elseif ( $order_data['payment_address_1'] ) {
				$address = $order_data['payment_address_1'];
			} else {
				$address = '';
			}

			//индекс не должен быть пустым
			if ( $order_data['shipping_postcode'] ) {
				$index = $order_data['shipping_postcode'];
			} elseif ( $order_data['payment_postcode'] ) {
				$index = $order_data['payment_postcode'];
			} elseif ( 'call ИМ' != $this->config->get( 'b2cpl_pak_type' ) ) {
				$index = '101000'; // Индекс Москвы по умолчанию
			}

			if ( $order_data['firstname'] ) {
				$fio = $order_data['firstname'] . ' ' . $order_data['lastname'];
			} else {
				$fio = '';
			}

			if ( $order_data['telephone'] ) {
				$tel = $order_data['telephone'];
			} else {
				$tel = '';
			}

			if ( $order_data['email'] && ( ! strstr( $order_data['email'], '@localhost' ) ) ) {
				$email = $order_data['email'];
			} else {
				$email = '';
			}


			$order_shipping_query = $this->db->query( "SELECT * FROM `" . DB_PREFIX . "order_total` WHERE order_id = '" . (int) $order_id . "' AND code='shipping' " );
			if ( $order_shipping_query->num_rows ) {
				$order_shipping = (float) $order_shipping_query->row['value'];
			} else {
				$order_shipping = 0;
			}

			//оплачен ли заказ
			$is_paid = 0;
//            if($order_data['order_status_id']==18){ //18-id статуса Оплачено
//                $is_paid=1;
//            }else{
//                $is_paid=0;
//            }

			if ( $is_paid ) {
				$order_shipping_to_pay = 0;

			} else {
				$order_shipping_to_pay = $order_shipping;
			}

			//товары
			$order_products      = array();
			$order_product_query = $this->db->query( "SELECT op.*, p.sku, p.weight, p.weight_class_id FROM " . DB_PREFIX . "order_product op LEFT JOIN " . DB_PREFIX . "product p ON ( op.product_id = p.product_id ) WHERE order_id = '" . (int) $order_id . "'" );

			$total_sum_w_deliv = 0;

			foreach ( $order_product_query->rows as $product ) {

				$option_data = array();

				$order_option_query = $this->db->query( "SELECT  oo . * , po.option_id FROM " . DB_PREFIX . "order_option oo LEFT JOIN " . DB_PREFIX . "product_option po ON ( po.product_option_id = oo.product_option_id ) WHERE order_id = '" . (int) $order_id . "' AND order_product_id = '" . (int) $product['order_product_id'] . "'" );

				foreach ( $order_option_query->rows as $option ) {
					if ( $option['type'] != 'file' ) {
						$value = $option['value'];
					} else {
						$value = utf8_substr( $option['value'], 0, utf8_strrpos( $option['value'], '.' ) );
					}


					$option_data[] = $option['name'] . ': ' . ( utf8_strlen( $value ) > 20 ? utf8_substr( $value, 0, 20 ) . '..' : $value );
				}
				$option_data_str = implode( ', ', $option_data );
				if ( $option_data_str ) {
					$product_name = $product['name'] . ' (' . $option_data_str . ')';
				} else {
					$product_name = $product['name'];
				}
				if ( $is_paid ) {
					$price_to_pay = 0;

				} else {
					$price_to_pay = $product['price'] + ( $this->config->get( 'config_tax' ) ? $product['tax'] : 0 );
				}

				$product_weight = $product['weight'];
				$weight_code    = utf8_strtoupper( $this->weight->getUnit( $product['weight_class_id'] ) );
				if ( $weight_code == 'KG' || $weight_code == 'КГ' ) {
					$product_weight *= 1000;
				}

				$order_products[]  = array(
					'name'         => $product_name,
					'sku'          => $product['sku'],
					'model'        => $product['model'],
					'weight'       => (int) $product_weight,
					'option'       => $option_data,
					'quantity'     => $product['quantity'],
					'price_nf'     => ( $product['price'] + ( $this->config->get( 'config_tax' ) ? $product['tax'] : 0 ) ),
					'price_to_pay' => $price_to_pay,
					'price'        => $this->currency->format( $product['price'] + ( $this->config->get( 'config_tax' ) ? $product['tax'] : 0 ), $order_data['currency_code'], $order_data['currency_value'] ),
					'total'        => $this->currency->format( $product['total'] + ( $this->config->get( 'config_tax' ) ? ( $product['tax'] * $product['quantity'] ) : 0 ), $order_data['currency_code'], $order_data['currency_value'] )
				);
				$total_sum_w_deliv += ( $product['price'] * $product['quantity'] + ( $this->config->get( 'config_tax' ) ? $product['tax'] * $product['quantity'] : 0 ) );
			}


			//определение способа доставки
			$delivery_type = $order_data['shipping_method'];
			$delivery_type = explode( ':', $delivery_type )[0];

			$calculate_total_weight = $this->getOrderWeight( $order_products );
			if ( $calculate_total_weight ) {
				$total_weight = $calculate_total_weight;
			} else {
				$total_weight = '';
			}
			//Комментарий
			if ( $order_data['comment'] ) {
				$comment = $order_data['comment'];
			} else {
				$comment = '';
			}


			//частичный отказ

			if ( ( $city == 'Санкт-Петербург' || $city == 'Москва' ) && ( $delivery_type == 'Курьер' ) ) {
				$partf = 'да';
			} else {
				$partf = 'нет';
			}

			$total_sum_w_deliv += $order_shipping;

			if ( ( $order_data['total'] != $total_sum_w_deliv ) && ( ! $is_paid ) ) {//когда итоговая сумма меняется сертификатами и пр.
				$skidka = $total_sum_w_deliv - $order_data['total'];
				foreach ( $order_products as $order_products_key => $order_products_item ) {

					if ( $order_products[ $order_products_key ]['price_to_pay'] * $order_products[ $order_products_key ]['quantity'] >= $skidka ) {
						$order_products[ $order_products_key ]['price_to_pay'] = ( $order_products[ $order_products_key ]['price_to_pay'] * $order_products[ $order_products_key ]['quantity'] - $skidka ) / $order_products[ $order_products_key ]['quantity'];
						$skidka                                                = 0;
						break;
					} else {
						$skidka                                                = $skidka - ( $order_products[ $order_products_key ]['price_to_pay'] * $order_products[ $order_products_key ]['quantity'] );
						$order_products[ $order_products_key ]['price_to_pay'] = 0;
					}
				}
				if ( $order_shipping_to_pay >= $skidka ) {
					$order_shipping_to_pay -= $skidka;
					$skidka                = 0;
				} else {
					$skidka                -= $order_shipping_to_pay;
					$order_shipping_to_pay = 0;
				}
			}
			$pak_type  = $this->config->get( 'b2cpl_pak_type' );
			$shop_name = $this->config->get( 'b2cpl_shop_name' );

			$data    = array();
			$data[0] = array(
				'Номер накладной',
				'Номер посылки',
				'Номер клиента',
				'Дата заказа',
				'Индекс',
				'Город',
				'Адрес',
				'ФИО',
				'Телефон мобильный',
				'Телефон дополнительный',
				'e-mail',
				'Вес посылки',
				'Полная стоимость доставки',
				'Стоимость доставки к оплате',
				'Артикул',
				'Товар',
				'Кол-во ед. товара',
				'Полная стоимость ед. товара',
				'Стоимость ед. товара к оплате',
				'Вес товара',
				'Тип доставки',
				'Доставка авиа',
				'Хрупкий товар',
				'Оценочная стоимость посылки',
				'Код b2c',
				'Условия доставки',
				'Упаковка',
				'Отправитель',
				'Дата доставки',
				'Интервал доставки',
				'Комментарии',
				'Частичный отказ'
			);

			foreach ( $order_products as $key => $item ) {
				if ( ! $key ) { //для первого продукта
					$data[] = array(
						'',
						$order_id,
						$customer_id,
						$order_data['date_added'],
						$index,
						$city,
						$address,
						$fio,
						$tel,
						'',
						$email,
						$total_weight,
						$order_shipping,
						$order_shipping_to_pay,
						$item['sku'],
						$item['name'],
						$item['quantity'],
						$item['price_nf'],
						$item['price_to_pay'],
						$item['weight'],
						$delivery_type,
						'',
						'',
						$total_sum_w_deliv,
						'',
						'',
						$pak_type,
						$shop_name,
						'',
						'',
						$comment,
						$partf
					);
				} else {
					$data[] = array(
						'',
						$order_id,
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						$item['sku'],
						$item['name'],
						$item['quantity'],
						$item['price_nf'],
						$item['price_to_pay'],
						$item['weight'],
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						''
					);
				}
			}


			foreach ( $data as $fields ) {
				fputcsv( $file, $fields, ";" );   /* записываем строку в csv-файл */
			}

			fclose( $file );
		}
	}

	/**
	 * Переход на новый API собираем JSON для отправки заказа в B2CPL
	 *
	 * @param $order_id
	 */
	public function sendPostJson( $order_id ) {

		if ( $order_id ) {
			$query_arr = array(
				'client' => $this->config->get( 'b2cpl_client' ),
				'key'    => $this->config->get( 'b2cpl_key' ),
				'func'   => 'order',
				'partner' => 'OpenCart 2.3',
			);

			$this->load->model( 'checkout/order' );
//			$path = $this->getOrderFile( $order_id );
//			echo $path;
//			$file = fopen( $path, 'wb' );

			$order_arr         = array();
			$order_data        = $this->model_checkout_order->getOrder( $order_id );
			$order_arr['code'] = $order_id;
			if ( $order_data['customer_id'] ) {
				$customer_id = $order_data['customer_id'];
			} else {
				$customer_id = '';
			}

			if ( $order_data['shipping_city'] ) {
				$order_arr['city'] = $order_data['shipping_city'];
			} elseif ( $order_data['payment_city'] ) {
				$order_arr['city'] = $order_data['payment_city'];
			} else {
				$order_arr['city'] = 'Не указан'; //Поле обязательно к заполнению
			}


			if ( $order_data['shipping_address_1'] ) {
				$order_arr['address'] = $order_data['shipping_address_1'];
			} elseif ( $order_data['payment_address_1'] ) {
				$order_arr['address'] = $order_data['payment_address_1'];
			} else {
				$order_arr['address'] = '';
			}

			//индекс не должен быть пустым
			if ( $order_data['shipping_postcode'] ) {
				$order_arr['zip'] = $order_data['shipping_postcode'];
			} elseif ( $order_data['payment_postcode'] ) {
				$order_arr['zip'] = $order_data['payment_postcode'];
			} elseif ( 'call ИМ' != $this->config->get( 'b2cpl_pak_type' ) ) {
				$order_arr['zip'] = '101000'; // Индекс Москвы по умолчанию
			}

			if ( $order_data['firstname'] ) {
				$order_arr['fio'] = $order_data['firstname'] . ' ' . $order_data['lastname'];
			} else {
				$order_arr['fio'] = '';
			}

			if ( $order_data['telephone'] ) {
				$order_arr['phone1'] = $order_data['telephone'];
			} else {
				$order_arr['phone1'] = '';
			}

			if ( $order_data['email'] && ( ! strstr( $order_data['email'], '@localhost' ) ) ) {
				$order_arr['email'] = $order_data['email'];
			} else {
				$order_arr['email'] = '';
			}


			$order_shipping_query = $this->db->query( "SELECT * FROM `" . DB_PREFIX . "order_total` WHERE order_id = '" . (int) $order_id . "' AND code='shipping' " );
			if ( $order_shipping_query->num_rows ) {
				$order_arr['price_delivery'] = (float) $order_shipping_query->row['value'];
			} else {
				$order_arr['price_delivery'] = 0;
			}

			//оплачен ли заказ
			$is_paid = 0;
//            if($order_data['order_status_id']==18){ //18-id статуса Оплачено
//                $is_paid=1;
//            }else{
//                $is_paid=0;
//            }

			if ( $is_paid ) {
				$order_arr['price_delivery_pay'] = 0;

			} else {
				$order_arr['price_delivery_pay'] = $order_arr['price_delivery'];
			}

			//товары
			$items               = array();
			$order_product_query = $this->db->query( "SELECT op.*, p.sku, p.weight, p.weight_class_id FROM " . DB_PREFIX . "order_product op LEFT JOIN " . DB_PREFIX . "product p ON ( op.product_id = p.product_id ) WHERE order_id = '" . (int) $order_id . "'" );

			$total_sum_w_deliv = 0;

			foreach ( $order_product_query->rows as $product ) {

				$option_data = array();

				$order_option_query = $this->db->query( "SELECT  oo . * , po.option_id FROM " . DB_PREFIX . "order_option oo LEFT JOIN " . DB_PREFIX . "product_option po ON ( po.product_option_id = oo.product_option_id ) WHERE order_id = '" . (int) $order_id . "' AND order_product_id = '" . (int) $product['order_product_id'] . "'" );

				foreach ( $order_option_query->rows as $option ) {
					if ( $option['type'] != 'file' ) {
						$value = $option['value'];
					} else {
						$value = utf8_substr( $option['value'], 0, utf8_strrpos( $option['value'], '.' ) );
					}


					$option_data[] = $option['name'] . ': ' . ( utf8_strlen( $value ) > 20 ? utf8_substr( $value, 0, 20 ) . '..' : $value );
				}
				$option_data_str = implode( ', ', $option_data );
				if ( $option_data_str ) {
					$product_name = $product['name'] . ' (' . $option_data_str . ')';
				} else {
					$product_name = $product['name'];
				}
				if ( $is_paid ) {
					$price_to_pay = 0;

				} else {
					$price_to_pay = $product['price'] + ( $this->config->get( 'config_tax' ) ? $product['tax'] : 0 );
				}

				$product_weight = $product['weight'];
				$weight_code    = utf8_strtoupper( $this->weight->getUnit( $product['weight_class_id'] ) );
				if ( $weight_code == 'KG' || $weight_code == 'КГ' ) {
					$product_weight *= 1000;
				}

				$items[]           = array(
					'prodname'     => $product_name,
					'prodcode'     => $product['sku'],
					'model'        => $product['model'],
					'weight'       => (int) $product_weight,
					'option'       => $option_data,
					'quantity'     => $product['quantity'],
					'price'        => ( $product['price'] + ( $this->config->get( 'config_tax' ) ? $product['tax'] : 0 ) ),
					'price_pay'    => $price_to_pay,
//					'price'    => $this->currency->format($product['price'] + ($this->config->get('config_tax') ? $product['tax'] : 0), $order_data['currency_code'], $order_data['currency_value']),
//					'total'    => $this->currency->format($product['total'] + ($this->config->get('config_tax') ? ($product['tax'] * $product['quantity']) : 0), $order_data['currency_code'], $order_data['currency_value'])
					'price_assess' => ( $product['price'] + ( $this->config->get( 'config_tax' ) ? $product['tax'] : 0 ) ),
					'vat'          => 0,
				);
				$total_sum_w_deliv += ( $product['price'] * $product['quantity'] + ( $this->config->get( 'config_tax' ) ? $product['tax'] * $product['quantity'] : 0 ) );

			}


			//определение способа доставки
			$delivery_type              = $order_data['shipping_method'];
			$delivery_type              = explode( ':', $delivery_type )[0];
			$order_arr['delivery_type'] = $delivery_type;

			$calculate_total_weight = $this->getOrderWeight( $items );
			if ( $calculate_total_weight ) {
				$total_weight = $calculate_total_weight;
			} else {
				$total_weight = '';
			}

			//Комментарий
			if ( $order_data['comment'] ) {
				$order_arr['comment'] = $order_data['comment'];
			} else {
				$order_arr['comment'] = '';
			}


			//частичный отказ

			$order_arr['flag_partial_reject'] = ( ( $order_arr['city'] == 'Санкт-Петербург' || $order_arr['city'] == 'Москва' ) && ( $delivery_type == 'Курьер' ) );

			$total_sum_w_deliv += $order_arr['price_delivery'];

			if ( ( $order_data['total'] != $total_sum_w_deliv ) && ( ! $is_paid ) ) {//когда итоговая сумма меняется сертификатами и пр.
				$skidka = $total_sum_w_deliv - $order_data['total'];
				foreach ( $items as $order_products_key => $order_products_item ) {

					if ( $items[ $order_products_key ]['price_pay'] * $items[ $order_products_key ]['quantity'] >= $skidka ) {
						$items[ $order_products_key ]['price_pay'] = ( $items[ $order_products_key ]['price_pay'] * $items[ $order_products_key ]['quantity'] - $skidka ) / $items[ $order_products_key ]['quantity'];
						$skidka                                    = 0;
						break;
					} else {
						$skidka                                    = $skidka - ( $items[ $order_products_key ]['price_pay'] * $items[ $order_products_key ]['quantity'] );
						$items[ $order_products_key ]['price_pay'] = 0;
					}
				}
				if ( $order_arr['price_delivery_pay'] >= $skidka ) {
					$order_arr['price_delivery_pay'] -= $skidka;
//					$skidka = 0;
				} else {
//					$skidka -= $order_arr['price_delivery_pay'];
					$order_arr['price_delivery_pay'] = 0;
				}
			}
			$pak_type  = $this->config->get( 'b2cpl_pak_type' );
			$shop_name = $this->config->get( 'b2cpl_shop_name' );

			$order_arr['sender']        = $shop_name;
			$order_arr['flag_call']     = strpos( $pak_type, 'call' ) !== false;
			$order_arr['flag_delivery'] = 'call ИМ' != $pak_type;
			$order_arr['flag_fitting']  = strpos( $pak_type, 'омни' ) !== false;

			$order_arr['parcels'] = array(
				array(
					'number' => '1',
					'code'   => $order_arr['code'],
					'items'  => $items,
				)
			);
			$query_arr['orders']  = array( $order_arr );
			$json_params          = json_encode( $query_arr );

			$defaults = array(
				CURLOPT_URL            => 'http://api.b2cpl.ru/services/api_client.ashx',
				CURLOPT_POST           => true,
				CURLOPT_HEADER         => false,
				CURLOPT_POSTFIELDS     => $json_params,
				CURLOPT_RETURNTRANSFER => true
			);
			$ch       = curl_init();
			curl_setopt_array( $ch, $defaults );
			$res = curl_exec( $ch );
			curl_close( $ch );

			file_put_contents( 'log.html', print_r( array( 'answer' => $json_params, 'response' => $res ), true ) );

			$responseData = json_decode( $res );
			//print_r($responseData);
			$error = false;
			if ( json_last_error() != JSON_ERROR_NONE ) {
				$message = "Bed response JSON :  " . $res . " \r\n   JSON message:    " . json_last_error_msg();
				$error   = true;
			} elseif ( property_exists( $responseData, 'success' ) ) {
				if ( ! $responseData->success ) {
					$message = $responseData->message;
					$error   = true;
				}
			} elseif ( property_exists( $responseData, 'orders' ) ) {

			}
			if ( $error ) {
				$this->sendError( $order_id, $message );
			}


		}
	}


	public function sendCsv( $order_id ) { //отправка файла В курьерскую службу B2CPL
		if ( $this->request->server['HTTPS'] ) {
			$server = $this->config->get( 'config_ssl' );
		} else {
			$server = $this->config->get( 'config_url' );
		}
		if ( is_file( $this->getOrderFile( $order_id ) ) ) {
			//данные клиента в системе b2cpl
			$b2cpl_url = 'http://is.b2cpl.ru/portal/client_api.ashx?';
			$params    = array(
				'client'   => $this->config->get( 'b2cpl_client' ),
				'key'      => $this->config->get( 'b2cpl_key' ),
				'func'     => 'upload',
				'file'     => $server . 'order_' . $order_id . '.csv',
				'report'   => 1,
				'stickers' => 1,
			);
			//данные клиента в системе b2cpl
			$ch = curl_init( $b2cpl_url . http_build_query( $params, null, '&' ) );
			curl_setopt_array( $ch, array(
				CURLOPT_RETURNTRANSFER => true
			) );

			// Send the request
			$response = curl_exec( $ch );


			// Check for errors
			if ( $response === false ) {
				die( curl_error( $ch ) );
			}

			$response2 = iconv( "windows-1251", "utf-8", $response );
			//print_r($response2);
			$responseData = json_decode( $response2 );
			//print_r($responseData);
			$error = false;
			if ( json_last_error() != JSON_ERROR_NONE ) {
				$message = "Bed response JSON :  " . $response2 . " \r\n   JSON message:    " . json_last_error_msg();
				$error   = true;
			} elseif ( property_exists( $responseData, 'flag_error' ) ) {
				if ( $responseData->flag_error ) {
					$message = $responseData->text_error;
					$error   = true;
				}
			}
			if ( $error ) {
				$this->sendError( $order_id, $message );
			}
			//и удалить файл
			$this->deleteCsv( $order_id );
		} else {
			return false;
		}

	}

	public function deleteCsv( $order_id ) { //удаление файла после успешной отправки
		if ( $order_id ) {
			unlink( $this->getOrderFile( $order_id ) );
		}
	}

	public function getOrderWeight( $order_products = array() ) {
		$order_weight = 0;
		foreach ( $order_products as $product ) {
			$order_weight += $product['weight'] * $product['quantity'];
		}

		return $order_weight;
	}


	public function getOrderFile( $order_id ) {
		$path = explode( 'index.php', $_SERVER['SCRIPT_NAME'] );
		$path = $path[0];

		return $_SERVER['DOCUMENT_ROOT'] . $path . 'order_' . $order_id . '.csv';
	}

	public function sendError( $order_id, $message ) {
		$subject         = 'Ошибка в обработке заказа №' . $order_id . ' службой B2C';
		$text            = 'Ошибка:' . $message;
		$mail            = new Mail();
		$mail->protocol  = $this->config->get( 'config_mail_protocol' );
		$mail->parameter = $this->config->get( 'config_mail_parameter' );
		$mail->hostname  = $this->config->get( 'config_smtp_host' );
		$mail->username  = $this->config->get( 'config_smtp_username' );
		$mail->password  = $this->config->get( 'config_smtp_password' );
		$mail->port      = $this->config->get( 'config_smtp_port' );
		$mail->timeout   = $this->config->get( 'config_smtp_timeout' );
		$mail->setTo( $this->config->get( 'config_email' ) );
		$mail->setFrom( $this->config->get( 'config_email' ) );
		$mail->setSender( $_SERVER['SERVER_NAME'] );
		$mail->setSubject( html_entity_decode( $subject, ENT_QUOTES, 'UTF-8' ) );
		$mail->setText( html_entity_decode( $text, ENT_QUOTES, 'UTF-8' ) );
		$mail->addAttachment( $this->getOrderFile( $order_id ) );
		$mail->send();
	}

}