<?php

/**
 * Created by Andrey Nekrylov
 * Date: 04.11.2016
 * Time: 4:32
 */
class ModelExtensionShippingB2cpl extends Model {
	private $b2cpl_url = 'http://api.b2cpl.ru/services/api_client.ashx';//'http://is.b2cpl.ru/portal/client_api.ashx?';

	function getQuote( $address ) {

		$this->load->language( 'extension/shipping/b2cpl' );
		if ( $this->config->get( 'b2cpl_pak_type' ) == 'call ИМ' ) {
			return array();
		}

		$query = $this->db->query( "SELECT * FROM " . DB_PREFIX . "zone_to_geo_zone WHERE geo_zone_id = '" . (int) $this->config->get( 'b2cpl_geo_zone_id' ) . "' AND country_id = '" . (int) $address['country_id'] . "' AND (zone_id = '" . (int) $address['zone_id'] . "' OR zone_id = '0')" );

		if ( ! $this->config->get( 'b2cpl_geo_zone_id' ) ) {
			$status = true;
		} elseif ( $query->num_rows ) {
			$status = true;
		} else {
			$status = false;
		}
		$error = false;

//        if ($this->cart->getSubTotal() < $this->config->get('b2cpl_total')) {
//            $status = false;
//        }

		$method_data = array();

		if ( $status ) {
			$weight = (float) $this->cart->getWeight();
			if ( $weight ) {
				$weight_code = utf8_strtoupper( $this->weight->getUnit( $this->config->get( 'config_weight_class_id' ) ) );
				if ( $weight_code == 'KG' || $weight_code == 'КГ' ) {
					$weight *= 1000;
				}

			} else {
				$weight = (int) $this->config->get( 'b2cpl_weight' );
			}
			if ( $weight < 1 ) {
				$weight = (int) $this->config->get( 'b2cpl_weight' );
			}


			$params = array(
				'address'      => $address['city'] . ',' . $address['address_1'],
				'client'       => $this->config->get( 'b2cpl_client' ),
				'key'          => $this->config->get( 'b2cpl_key' ),
//				'type'         => $this->config->get( 'b2cpl_type' ),
				'route_code'   => 1,
				'func'         => 'tarif',
				'region'       => $this->config->get( 'b2cpl_region' ) ? (int) $this->config->get( 'b2cpl_region' ) : 77,
				'parcels'      => array(
					array(
						'weight' => (int) $weight,
					),
				),
				'price_assess' => (float) $this->cart->getTotal(),
				'price_amount' => (float) $this->cart->getTotal(),
				'flag_courier' => true,
				'flag_pvz'     => true,
				'flag_post'    => true,
			);
			if ( $address['postcode'] != '' && mb_strlen( $address['postcode'] ) == 6 ) {
				$params['zip'] = $address['postcode'];
			}

//            $delivery_response = $this->sendGetRequest($this->b2cpl_url.http_build_query($params,null,'&'));
//            $delivery_types = json_decode($delivery_response,true);
			$delivery_types = $this->sendPost( $params );

			$quote_data = array();
			if ( $delivery_types && $delivery_types['success'] ) {
				if ( $delivery_types['flag_delivery'] ) {
					$i = 1;
					foreach ( array( 'delivery_courier', 'delivery_pvz', 'delivery_post' ) as $delivery_type ) {
						if ( ! $delivery_types[ $delivery_type ] ) {
							continue;
						}
						foreach ( $delivery_types[ $delivery_type ] as $wey ) {
							if ( $this->config->get( 'b2cpl_is_fix_price' ) ) {
								$wey['price'] = (float) $this->config->get( 'b2cpl_fix_price' );
							}
							$quote_data[ 'b2cpl' . $i ] = array(
								'code'         => 'b2cpl.b2cpl' . $i,
								'title'        => $wey['code'] . ':' . $wey['name'] . ' ' . ( array_key_exists( 'address', $wey ) ? $wey['address'] : '' ),
								'cost'         => (float) $wey['price'],
								'tax_class_id' => 0,
								'text'         => $this->currency->format( (float) $wey['price'], $this->session->data['currency'] )
							);
							$i ++;
						}
					}
				} else {
					$error = $this->language->get( 'error_message' );
//                $error = '---'.count($delivery_types['delivery_ways']).$delivery_types['flag_delivery'].'<br>'.$delivery_response.
					'<br>' . $this->b2cpl_url . http_build_query( $params, null, '&' );

				}
			} else {
				$error = $delivery_types ? $delivery_types['message'] : $error = $this->language->get( 'error_request' );
			}
//            $quote_data['b2cpl'] = array(
//                'code'         => 'b2cpl.b2cpl',
//                'title'        => $this->language->get('text_description'),
//                'cost'         => 0.00,
//                'tax_class_id' => 0,
//                'text'         => $this->currency->format(0.00)
//            );

			{
				$method_data = array(
					'code'       => 'b2cpl',
					'title'      => $this->language->get( 'text_title' ),
					'quote'      => $quote_data,
					'sort_order' => $this->config->get( 'b2cpl_sort_order' ),
					'error'      => $error
				);
			}
		}

		return $method_data;

	}

	function sendGetRequest( $cmdUrl ) {
		$sh = curl_init( $cmdUrl );
		curl_setopt( $sh, CURLOPT_RETURNTRANSFER, 1 );
		curl_setopt( $sh, CURLOPT_HEADER, 0 );
		$res = curl_exec( $sh );
		curl_close( $sh );

		return iconv( 'windows-1251', 'UTF-8', $res );
	}

	function sendPost( $params ) {
		if ( is_array( $params ) ) {
			$params = json_encode( $params );
			if ( json_last_error() ) {
				return false;
			}
		}

		$defaults = array(
			CURLOPT_URL            => $this->b2cpl_url, //'http://api.b2cpl.ru/services/api_client.ashx',
			CURLOPT_POST           => true,
			CURLOPT_HEADER         => false,
			CURLOPT_POSTFIELDS     => $params,
			CURLOPT_RETURNTRANSFER => true
		);
		$ch       = curl_init();
		curl_setopt_array( $ch, $defaults );
		$res = curl_exec( $ch );
		curl_close( $ch );
		$ret = json_decode( $res, true );
		if ( json_last_error() ) {
			return false;
		}

		return $ret;
	}
}